#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5 * 1e5 + 1;
const int MAXVALUE = 1e7 + 1;
const int MAXSQRT = 1e4 + 1;
int N;
int A[MAXN];
bool Visited[MAXVALUE];
bool Prime[MAXSQRT];
vector<int> Primes;
map<int, vector<int>> Graph;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Sieve()
{
    Prime[0] = true;
    Prime[1] = true;

    for(int i = 2; i * i < MAXSQRT; i++)
    {
        if(Prime[i])
        {
            continue;
        }

        for(int j = i * i; j < MAXSQRT; j += i)
        {
            Prime[j] = true;
        }
    }

    for(int i = 2; i < MAXSQRT; i++)
    {
        if(!Prime[i])
        {
            Primes.push_back(i);
        }
    }
}

void Read()
{
    cin >> N;

    for(int i = 0; i < N; i++)
    {
        cin >> A[i];
    }

    sort(A, A + N);
    reverse(A, A + N);
}

void Add(int Value)
{
    int Root = Value;

    for(int i = 0; Primes[i] * Primes[i] <= Value; i++)
    {
        if(Value % Primes[i] != 0)
        {
            continue;
        }

        Graph[Root].push_back(Primes[i]);
        Graph[Primes[i]].push_back(Root);

        while(Value % Primes[i] == 0)
        {
            Value /= Primes[i];
        }
    }

    if(Value != 1)
    {
        Graph[Root].push_back(Value);
        Graph[Value].push_back(Root);
    }
}

void Dfs(int U)
{
    if(Visited[U])
    {
        return;
    }

    Visited[U] = true;

    for(auto& V:Graph[U])
    {
        Dfs(V);
    }
}

void Solve()
{
    for(int i = 0; i < N; i++)
    {
        Add(A[i]);
    }

    int Ans = 0;

    for(int i = 0; i < N; i++)
    {
        if(Visited[A[i]])
        {
            continue;
        }

        Ans++;
        Dfs(A[i]);
    }

    cout << Ans;
}

int main()
{
    FastEJOI();
    Sieve();
    Read();
    Solve();
    return 0;
}
