#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <bitset>
#include <utility>
using namespace std;
#define ll long long

int prime[664580];
int a[500001];
bitset<10000001> composite;
int prFact[664580];
vector<int>* group[500001];
bitset<500001> merged;


vector<int> merge(vector<int> a, vector<int> b) {
    vector<int> ans;
    int j = 0, k = 0;
    while (j < a.size() || k < b.size()) {
        if (j >= a.size() || (k < b.size() && a[j] > b[k])) {
            ans.push_back(b[k++]);
            continue;
        }
        if (k >= b.size() || a[j] < b[k]) {
            ans.push_back(a[j++]);
            continue;
        }
        if (a[j] == b[k]) {
            ans.push_back(a[j++]);
            k++;
        }
    }
    return ans;
}

void factor(int x, int idx) {
    if (x == 1) {
        group[idx - 1] = new vector<int>();
        group[idx - 1]->push_back(1);
        return;
    }
    bool mergedCur = 0;
    vector<int>* cur = new vector<int>();
    cur->clear();
    for (int i = 0; prime[i]/* * prime[i]*/ <= x; i++) {
        if (x % prime[i] == 0) {
            if (prFact[i] == 0) {
                prFact[i] = idx;
                cur->push_back(prime[i]);
            } else {
                if (mergedCur) {
                    merged[prFact[i] - 1] = 1;
                }
                *group[prFact[i] - 1] = merge(*group[prFact[i] - 1], *cur);
                cur = group[prFact[i] - 1];
                mergedCur = 1;
            }
        }
    }
    merged[idx - 1] = mergedCur;
    group[idx - 1] = cur;
}


int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cnt = 0;
    for (ll i = 2; i * i < 10000000; i++) {
        if (!composite[i]) {
            prime[cnt] = i;
            cnt++;
            for (ll j = i * i; j < 10000000; j += i) {
                composite[j] = 1;
            }
        }
    }

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        factor(a[i], i + 1);
    }
//    for (int i = 0; i < n; i++) {
//        cout << i << ": ";
//        for (int j = 0; j < group[i]->size(); j++) {
//            cout << (*group[i])[j] << " ";
//        }
//        cout << "\n";
//    }

    sort(group, group + n);
    cnt = 0;
    for (int i = 0; i < n; i++) {
        if (i != n - 1 && group[i] == group[i + 1]) {
            continue;
        }
        cnt++;
    }
    cout << cnt;
}
