#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 5e5 + 10;
const ll MAXA = 1e7 + 10;

ll n;
ll leader[MAXA];
ll sizes[MAXA];
ll p[MAXA];
bool prime[MAXA];
vector<ll>divs[MAXN];
ll a[MAXN];
ll cnt1;
ll cnts;
ll maxel;

void sieve()
{
    prime[0] = prime[1] = false;
    for(ll i = 2; i <= maxel; i++)
    {
        if(!p[i])
        {
            prime[i] = true;
            p[i] = i;
            for(ll j = 2 * i; j <= maxel; j += i)
            {
                if(p[j] == 0)
                    p[j] = i;
            }
        }
    }
    /**
    for(int i = 1; i <= 10; i++)
    {
        cout << i << " - >" << prime[i] << " " << p[i] << endl;
    }
    */
}

void divide(ll x, ll idx)
{
    while(x != 1)
    {
        ll nxt = p[x];
        if(sizes[nxt] == 0)
        {
            cnts++;
            sizes[nxt]++;
        }
        if(divs[idx].empty() || nxt != divs[idx].back())
        {
            divs[idx].push_back(nxt);
        }
        x /= nxt;
    }
}

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
        cnt1 += (a[i] == 1);
        maxel = max(maxel, a[i]);
    }
}

void print()
{
    for(int i = 1; i <= n; i++)
    {
        ll sz = divs[i].size();
        for(int j = 0; j < sz; j++)
        {
            cout << divs[i][j] << " ";
        }
        cout << endl;
    }
}

ll find_leader(ll u)
{
    return leader[u] == u ? u : leader[u] = find_leader(leader[u]);
}

bool connected(ll u, ll v)
{
    return find_leader(u) == find_leader(v);
}

void unite(ll u, ll v)
{
    u = find_leader(u);
    v = find_leader(v);

    if(sizes[u] < sizes[v])
        swap(u, v);

    sizes[u] += sizes[v];
    leader[v] = u;
    cnts--;
}

void init()
{
    for(ll i = 1; i <= maxel; i++)
    {
        leader[i] = i;
        sizes[i] = 0;
    }
}

void divide_all()
{
    for(ll i = 1; i <= n; i++)
    {
        if(a[i] == 1)
            continue;
        divide(a[i], i);
    }
}

void solve()
{
    for(ll i = 1; i <= n; i++)
    {
        if(a[i] == 1)
            continue;
        ///cout << i << " -> " << cnts << endl;
        ll sz = divs[i].size();
        for(ll j = 1; j < sz; j++)
        {
            ll u = divs[i][j];
            ll v = divs[i][j - 1];

            if(!connected(u, v))
                unite(u, v);
        }
    }
    cout << cnts + cnt1 << endl;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    sieve();
    init();
    divide_all();
    ///print();
    solve();

    return 0;
}
